<?php
require("localSidebar.php");
require("graph/navbar.inc.php");
require("modules/vlan/includes/parser.inc.php");

if($_GET['action'] == 'add'){
	$title = _T('Add VLAN Interface','vlan');
	$mode = 'add';
	$vlan_interface="";
	$vlan_addr="";
	$vlan_tag="";
	$vlan_gw="";
	$vlan_broad="";
	$vlan_mask="";
	$vlan_dns="";
	$vlan_comment="";
}else{
	$title = _T('Edit VLAN Interface','vlan');
	$mode = 'edit';
	$sidemenu->forceActiveItem("index");
	$vlanConf=array();
	$temp=array();
	$vlan = $_GET['vlan'];
	$vlanConf = getVlanID($vlan);
	$temp=explode(".", $vlan); //Tag (this will be the same and will no be changed in edit mode)
	$vlan_tag=$temp[1];

	$vlan_interface=$temp[0]; //interface

	$temp=explode("=",$vlanConf[3]); // ip
	$vlan_addr=$temp[1];

	$temp=explode("=",$vlanConf[4]); //netmask
	$temp[1]=convertToCIDR($temp[1]);
	$vlan_mask=$temp[1];

//	$temp=explode("=",$vlanConf[4]); //dns
//	$vlan_dns=$temp[1];

//	$temp=explode("=", $vlanConf[5]); //gateway
//	$vlan_gw=$temp[1];

//	$temp=explode("=",$vlanConf[7]); //broadcast
//	$vlan_broad=$temp[1];

	$temp=explode("=",$vlanConf[6]); //comment
	$vlan_comment=$temp[1];
}

$p = new PageGenerator();
$p->setTitle($title);
$p->setSideMenu($sidemenu);
$p->display();

//TODO: test inputs from user
if(isset($_POST["badd"])){
	$vlan_interface=$_POST["interfaces-available"];
	$vlan_addr=$_POST["vlan_addr"];
	$vlan_tag=$_POST["vlan_tag"];
//	$vlan_gw=$_POST["vlan_gw"]; not needed but it is still avaible to use
//	$vlan_broad=$_POST["vlan_broad"];
	$vlan_mask=$_POST["vlan_mask"];
//	$vlan_dns=$_POST["vlan_dns"];
	$vlan_gw=$vlan_broad=$vlan_dns='';
	$is_add = 1;
	$vlan_comment=$_POST["vlan_comment"];
	$return = addVlan($vlan_interface, $vlan_addr, $vlan_mask, $vlan_tag, $vlan_comment, $is_add, $vlan_broad, $vlan_dns, $vlan_gw);
	if($return == 2 && !isXMLRPCError()){
		$result = _T("Error, the VLAN file with that tag already exists.", "vlan") . "<br />";
		new NotifyWidgetFailure($result);
		setFormError("vlan_tag");
	}elseif($return == 3 && !isXMLRPCError()){
		$result = _T("Warning, the shorewall file -> '/etc/shorewall/zones', does not exists. No rule create for this vlan.", "vlan") . "<br />";
		new NotifyWidgetWarning($result);
	}elseif($return == 4 && !isXMLRPCError()){
		$result = _T("Warning, the shorewall file -> '/etc/shorewall/interfaces', does not exists. No rule create for this vlan.", "vlan") . "<br />";
		new NotifyWidgetWarning($result);
	}elseif($return == 5 && !isXMLRPCError()){
		$result = _T("Warning, the shorewall file -> '/etc/shorewall/policy', does not exists. No rule create for this vlan.", "vlan") . "<br />";
		new NotifyWidgetWarning($result);
	}elseif($return == 6 && !isXMLRPCError()){
		$result = _T("Warning, the shorewall file -> '/etc/shorewall/rules', does not exists. No rule create for this vlan.", "vlan") . "<br />";
		new NotifyWidgetWarning($result);
	}elseif($return == 7 && !isXMLRPCError()){
		$result = _T("This IP address already belongs to another subnet created.", "vlan") . "<br />";
		new NotifyWidgetWarning($result);
		setFormError("vlan_addr");
		setFormError("vlan_mask");
	}elseif($return == 8 && !isXMLRPCError()){
		$result = _T("Can not use subnet id. Please use valid ip address for this subnet.", "vlan") . "<br />";
		new NotifyWidgetWarning($result);
		setFormError("vlan_addr");
	}elseif(!isXMLRPCError() && $return == 1){
		$result = _T("The VLAN configuration was been add.Please restart the DHCP service.", "vlan") . "<br />";
		$adv = new NotifyWidgetSuccess($result);
		$services = getServicesNames();
		handleServicesModule($adv, array($services[1] => "DHCP"));
		redirectTo(urlStrRedirect("vlan/vlan/index"));
	}
}elseif(isset($_POST["bedit"])){ //no change in tag nor vlan_interface
	$vlan_addr=$_POST["vlan_addr"];
	//$vlan_gw=$_POST["vlan_gw"];
	//$vlan_broad=$_POST["vlan_broad"];
	$vlan_mask=$_POST["vlan_mask"];
	//$vlan_dns=$_POST["vlan_dns"];
	$vlan_comment=$_POST["vlan_comment"];
	$vlan_gw=$vlan_broad=$vlan_dns='';
	$is_add = 0;
	addVlan($vlan_interface, $vlan_addr, $vlan_mask, $vlan_tag, $vlan_comment, $is_add, $vlan_broad, $vlan_dns, $vlan_gw);
	if(!isXMLRPCError()){
		$result = _T("The VLAN configuration has been modified. Please restart the DHCP service.", "vlan") . "<br />";
		$adv = new NotifyWidgetFailure($result);
		$services = getServicesNames();
		handleServicesModule($adv, array($services[1] => "DHCP"));
		redirectTo(urlStrRedirect("vlan/vlan/index"));

	}
}

$f = new ValidatingForm();
if($mode == 'edit'){
	$f->push(new Table());
	$f->add(
		new TrFormElement(_T("VLAN Interface"), new HiddenTpl("vlan_interface")),
		array("value"=> $vlan_interface, "required" => True)
	);
	$f->pop();
}
$f->push(new Table());

//vlan name (only changeable in add mode)
$aux = 0;
if ($mode == 'add'){
	$tagInput = new VlanTag("vlan_tag");
	$aux = 1;
}
else
	$tagInput = new HiddenTpl("vlan_tag");
if($aux == 1){
$f->add(
	new TrFormElement(_T("VLAN Tag"), $tagInput),
		array("value" => $vlan_tag, "required" => True, "extra" => _T(" e.g. only numbers in this range 1 to 4094"))
	);
}else{
$f->add(
	new TrFormElement(_T("VLAN Tag"), $tagInput),
		array("value" => $vlan_tag, "required" => True)
	);
}


//vlan address
$f->add(
	new TrFormElement(_T("VLAN Address"), new IPInputTpl("vlan_addr")),
		array("value" => $vlan_addr, "required" => True)
);
//netmask
$f->add(
	new TrFormElement(_T("Network mask"), new NetmaskInputTpl("vlan_mask")),
		array("value" => $vlan_mask, "required" => True, "extra" => _T(" e.g. 24 for a /24 network"))
);
/*		not needed in this project
//Broadcast
$f->add(
       new TrFormElement(_T("Broadcast"), new IPInputTpl("vlan_broad")),
		array("value" => $vlan_broad, "required" => True)
);

//gateway
$f->add(
	new TrFormElement(_T("Gateway"), new IPInputTpl("vlan_gw")),
	        array("value" => $vlan_gw, "required" => True)
);
//dns
$f->add(
	new TrFormElement(_T("DNS"), new IPInputTpl("vlan_dns")),
		array("value" => $vlan_dns, "required" => True)
);
 */
$f->add(
	new TrFormElement(_T("Commentary"), new InputTpl("vlan_comment")),
		array("value" => $vlan_comment, "extra" => _T(" * not required"))
);

//interfaces (chageable in add mode only)
if($mode == 'add'){
	$interfaces = new SelectItem("interfaces-available");
    $types=get_interfaces();
	$interfaces->setElements($types);
    $interfaces->setElementsVal($types);
    $interfaces->setSelected($types);
	$f->add(
        new TrFormElement(_T("Interfaces Available"),$interfaces));
}

//finish the page
$f->pop();//finish table
if($mode == 'add')
	$f->addButton("badd", _T("Create"));
else
	$f->addButton("bedit", _T("Confirm"));
$f->pop(); //finish button
$f->display();

?>

